Description
How about providing Binding#source_location?

b = binding
p binding.source_location #=> ["test.rb", 1]

To fetch the information, people uses a dirty idiom: eval("[__FILE__, _ LINE__]", binding).

e https://github.com/ruby/ruby/blob/trunk/lib/irb/workspace.rb#L 111
e https://github.com/rspec-given/rspec-given/blob/19e9ef24c159f5a014a9f22ebb94161d6ac5af43/lib/given/module_methods.rb#L
35

e https:/github.com/quix/live_ast/blob/7adaabdbb99dbc649fef4dfd8a821d9f347ccof2/lib/live ast/common.rb#L 37
¢ https://github.com/wesabe/robot-army/blob/29¢c50d3a5f2258c917fef821103fb0f107edb428/lib/robot-army/eval_builder.rb#lL.14

I noticed this issue when changing the semantics of eval so that it does not inherit __FILE__ from the binding. [#4352]

diff --git a/lib/irb/workspace.rb b/lib/irb/workspace.rb
index 9ce84b60fa..5216520£32 100644
-—— a/lib/irb/workspace.rb
+++ b/lib/irb/workspace.rb
@@ -108,7 +108,7 @@ def filter_backtrace (bt)
end

def code_around_binding
= file, pos = @binding.eval('[__FILE_ , _ LINE_ 1"')

+ file, pos = @binding.source_location
unless defined? (::SCRIPT_LINES_ [file]) && lines = ::SCRIPT_LINES__ [file]
begin

diff --git a/proc.c b/proc.c
index 9dbc78aeda..23c4d3a2d4 100644
--— a/proc.c
+++ b/proc.c
@@ -12,6 +12,7 Q@
#include "eval_intern.h"
#include "internal.h"
#include "gc.h"
+#include "vm_core.h"
#include "iseqg.h"

/* Proc.new with no block will raise an exception in the future
@R -611,6 +612,24 @R bind_receiver (VALUE bindval)
return vm_block_self (&bind->block);
}

A

+ * call-seq:

+ * binding.source_location -> [String, Integer]

+ *

+ * Returns the Ruby source filename and line number of the binding object.
+ */

+static VALUE

+bind_location (VALUE bindval)
+{

+ VALUE loc[2];
const rb_binding_t *bind;
GetBindingPtr (bindval, bind);

loc[0] = pathobj_path (bind->pathobj);
loc[1l] = INT2FIX(bind->first_lineno);

return rb_ary_newd (2, loc);

+ + + + + + + +

static VALUE
cfunc_proc_new (VALUE klass, VALUE ifunc, int8_t is_lambda)
{
@@ -3223,5 +3242,6 @@ Init_Binding(void)
rb_define_method (rb_cBinding, "local_variable_set", bind_local_variable_set,

rb_define_method (rb_cBinding, "local_variable_defined?", bind_local_variable_defined_p,

rb_define_method (rb_cBinding, "receiver", bind_receiver, 0);
+ rb_define_method (rb_cBinding, "source_location", bind_location, 0);
rb_define_global_function ("binding", rb_f_binding, 0);

2);

1);

Associated revisions

Revision 571e48b7 - 12/26/2017 08:38 AM - mame (Yusuke Endoh)

proc.c (bind_location): Add Binding#source_location
Fixes #14230

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@61480 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 61480 - 12/26/2017 08:38 AM - mame (Yusuke Endoh)

proc.c (bind_location): Add Binding#source_location

Fixes #14230

Revision 61480 - 12/26/2017 08:38 AM - mame (Yusuke Endoh)

proc.c (bind_location): Add Binding#source_location

Fixes #14230
Revision 3095f4ec - 02/21/2018 05:06 PM - mame (Yusuke Endoh)

e NEWS: add NEWS entry about Binding#source_location [Feature #14230]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62517 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 62517 - 02/21/2018 05:06 PM - mame (Yusuke Endoh)

¢ NEWS: add NEWS entry about Binding#source_location [Feature #14230]
Revision 62517 - 02/21/2018 05:06 PM - mame (Yusuke Endoh)

o NEWS: add NEWS entry about Binding#source_location [Feature #14230]

History

#1 - 12/25/2017 12:51 PM - shevegen (Robert A. Heiler)

| like introspection so | am usually in agreement with all ways
to inspect ruby's behaviour.

+1

| also agree that eval-binding is not pretty.

#2 - 12/26/2017 08:17 AM - matz (Yukihiro Matsumoto)
Agreed.

Matz.
#3 - 12/26/2017 08:38 AM - mame (Yusuke Endoh)
- Status changed from Open to Closed

Applied in changeset trunk|r61480.

proc.c (bind_location): Add Binding#source_location

Fixes #14230
